#!/usr/bin/env python3
# -*- coding: utf-8 -*-
# File name          : app.py
# Author             : Podalirius (@podalirius_)
# Date created       : 2 Aug 2021

import sqlite3
import time
import random
from flask import Flask, send_from_directory

app = Flask(__name__)

def db_search(query):
    # CREATE TABLE users(id INTEGER AI PRIMARY KEY, username TEXT, name TEXT, lastname TEXT, UNIQUE(username, name, lastname) )
    conn = sqlite3.connect("database.db")
    cursor = conn.cursor()
    cursor.execute("SELECT id, username, firstname, lastname, age FROM users WHERE username LIKE ? LIMIT 100", (query + "%",))
    rows = cursor.fetchall()
    conn.close()
    return [{'id':r[0], 'username':r[1], 'firstname':r[2], 'lastname':r[3], 'age':r[4]} for r in rows]

#===

@app.route("/")
def api_home():
    return send_from_directory('./pages/', 'index.html')

@app.route("/api/search/")
def api_search_home():
    return {"error": "You must supply a query to the endpoint like this /api/search/<query>. Try for example /api/search/test"}

@app.route("/api/search/<query>")
def api_search(query):
    data = db_search(query)
    # time.sleep(0.3) # Simulate response time of heavy app
    if len(data) == 100:
        return {
            "results": data[:100],
            "message": "Limited search results to the first 100 entries."
        }
    else:
        return {
            "results": data,
            "message": "%d results." % len(data)
        }


if __name__ == '__main__':
    app.run(host="0.0.0.0")
